package spoke.connection;

import java.io.Serializable;
import java.io.ObjectOutputStream;
import java.io.ObjectInputStream;
import java.io.IOException;

public class ConnectionSupport implements java.io.Serializable {
    public ConnectionSupport(Object sourceBean) {
	source = sourceBean;
    }

    public synchronized void addConnectionListener(
				ConnectionListener listener) {
	if (listeners == null) {
	    listeners = new java.util.Vector();
	}
	listeners.addElement(listener);
    }

    public synchronized void removeConnectionListener(
				ConnectionListener listener) {
	if (listeners == null) {
	    return;
	}
	listeners.removeElement(listener);
    }

    public void fireConnection(String cmd) {

	java.util.Vector targets;
	synchronized (this) {
	    if (listeners == null) {
	    	return;
	    }
	    targets = (java.util.Vector) listeners.clone();
	}
        ConnectionEvent evt = new ConnectionEvent(source,cmd,0,0);

	for (int i = 0; i < targets.size(); i++) {
	    ConnectionListener target = (ConnectionListener)targets.elementAt(i);
	    target.connection(evt);
	}
    }


    private void writeObject(ObjectOutputStream s) throws IOException {
        s.defaultWriteObject();

	java.util.Vector v = null;
	synchronized (this) {
	    if (listeners != null) {
	        v = (java.util.Vector) listeners.clone();
            }
	}

	if (v != null) {
	    for(int i = 0; i < v.size(); i++) {
	        ConnectionListener l = (ConnectionListener)v.elementAt(i);
	        if (l instanceof Serializable) {
	            s.writeObject(l);
	        }
            }
        }
        s.writeObject(null);
    }


    private void readObject(ObjectInputStream s) throws ClassNotFoundException, IOException {
        s.defaultReadObject();
      
        Object listenerOrNull;
        while(null != (listenerOrNull = s.readObject())) {
	  addConnectionListener((ConnectionListener)listenerOrNull);
        }
    }

    transient private java.util.Vector listeners;
    private Object source;
    private int ConnectionSupportSerializedDataVersion = 1;
}
