package spoke.connection;

import java.io.*;

public abstract class Module implements Connectable, Serializable {
	protected Connector connector;
	protected transient boolean stopped;

	public Module() {
		connector=new Connector(this,1,1);
	}

	public void stop() {
		stopped=true;
	}

	public void open() {}

	public void close() {}

	public void connect(Connectable dest, OutputStream os, int nout) {
		connector.connect(dest,os,nout);
	}

	public void disconnect(Connectable dest) {
		connector.disconnect(dest);
	}

	public void connection(ConnectionEvent e) {
		connector.connection(e);
	}

	public synchronized void addConnectionListener(ConnectionListener l) {
		connector.addConnectionListener(l);
	}

	public synchronized void removeConnectionListener(ConnectionListener l) {
		connector.removeConnectionListener(l);
	}
}
