package spoke.math.numeric;

import spoke.util.*;

public abstract class Arithmetic implements spoke.util.Comparable {
	public abstract Arithmetic add(double d);
	public abstract Arithmetic subtract(double d);
	public abstract Arithmetic multiply(double d);
	public abstract Arithmetic divide(double d) throws ArithmeticException;
	public abstract Arithmetic add(Arithmetic arithmetic);

	public Arithmetic subtract(Arithmetic arithmetic) {
		return add(arithmetic.negate());
	}

	public abstract Arithmetic multiply(Arithmetic arithmetic);
	public abstract Arithmetic divide(Arithmetic arithmetic);

	public Arithmetic pow(int exponent) {
		Arithmetic a=SpokeDouble.valueOf(1.);
		for(int i=0;i<exponent;i++) a=a.multiply(this);
		return a;
	}

	public abstract Arithmetic negate();
	public abstract int signum();
	public abstract Arithmetic valueof(double d);

	public int compareTo(spoke.util.Comparable comparable) {
		return 0;
	}

	protected abstract Arithmetic newinstance();
}
