package spoke.math.numeric;

import java.io.*;

//public class Complex extends SpokeVector implements Serializable {
public class Complex extends Arithmetic implements Serializable {
	private static final Complex ZERO=new Complex();
	private static final Complex ONE=new Complex();
	static { ONE.element0=1.0; }
	public double element0;
	public double element1;

//	public Complex(double element[]) {
//		super(element);
//	}

	Complex() {}

	public Arithmetic add(double d) {
		Complex c=new Complex();
		c.element0=element0+d;
		c.element1=element1;
		return c;
	}

	public Arithmetic subtract(double d) {
		Complex c=new Complex();
		c.element0=element0-d;
		c.element1=element1;
		return c;
	}

	public Arithmetic multiply(double d) {
		Complex c=new Complex();
		c.element0=element0*d;
		c.element1=element1*d;
		return c;
	}

	public Arithmetic divide(double d) {
		Complex c=new Complex();
		c.element0=element0/d;
		c.element1=element1/d;
		return c;
	}

	public Arithmetic add(Arithmetic arithmetic) {
		Complex d=(Complex)arithmetic;
		Complex c=new Complex();
		c.element0=element0+d.element0;
		c.element1=element1+d.element1;
		return c;
	}

	public Arithmetic subtract(Arithmetic arithmetic) {
		Complex d=(Complex)arithmetic;
		Complex c=new Complex();
		c.element0=element0-d.element0;
		c.element1=element1-d.element1;
		return c;
	}

//	public Arithmetic multiply(Arithmetic arithmetic) {
//		double m[][]={
//			{element[0],-element[1]},
//			{element[1],element[0]}
//		};
//		return new Matrix(m).multiply(arithmetic);
//	}

	public Arithmetic multiply(Arithmetic arithmetic) {
		Complex d=(Complex)arithmetic;
		Complex c=new Complex();
		c.element0=element0*d.element0-element1*d.element1;
		c.element1=element1*d.element0+element0*d.element1;
		return c;
	}

//	public Arithmetic divide(Arithmetic arithmetic) {
//		Complex d=(Complex)arithmetic;
//		return multiply(d.conjugate()).divide(d.modulus2());
//	}

	public Arithmetic divide(Arithmetic arithmetic) {
		Complex d=(Complex)arithmetic;
		Complex c=new Complex();
		c.element0=element0*d.element0+element1*d.element1;
		c.element1=element1*d.element0-element0*d.element1;
		return c.divide(d.modulus2());
	}

	public Arithmetic negate() {
		Complex c=new Complex();
		c.element0=-element0;
		c.element1=-element1;
		return c;
	}

	public int signum() {
		return 0;
	}

	public Arithmetic valueof(double d) {
		Complex c=new Complex();
		c.element0=d;
		return c;
	}

	public double modulus() {
		return Math.sqrt(element0*element0+element1*element1);
	}

//	public double modulus2() {
//		return scalarProduct(this);
//	}

	public double modulus2() {
		return element0*element0+element1*element1;
	}

	public double phase() {
		return Math.atan2(element1,element0);
	}

	public Complex conjugate() {
		Complex c=new Complex();
		c.element0=element0;
		c.element1=-element1;
		return c;
	}

	public Complex log() {
		Complex c=new Complex();
		c.element0=Math.log(modulus());
		c.element1=phase();
		return c;
	}

	public Complex log(double threshold) {
		double m=modulus();
		double p;
		if(m>threshold) p=phase();
		else {
			m=threshold;
			p=0.;
		}
		Complex c=new Complex();
		c.element0=Math.log(m);
		c.element1=p;
		return c;
	}

	public Complex exp() {
		Complex c=new Complex();
		c.element0=Math.cos(element1);
		c.element1=Math.sin(element1);
		return (Complex)c.multiply(Math.exp(element0));
	}

	public static Complex valueOf(double re, double im) {
		if(re==0.0 && im==0.0) return ZERO;
		else if(re==1.0 && im==0.0) return ONE;
		else {
//			Complex c=new Complex(new double[2]);
			Complex c=new Complex();
			c.element0=re;
			c.element1=im;
			return c;
		}
	}

	protected Arithmetic newinstance() {
		return null;
	}

//	protected Arithmetic newinstance(int n) {
//		return new Complex(new double[2]);
//	}
}
