package spoke.math.numeric;

public class SpokeDouble extends Arithmetic {
	double content;

	SpokeDouble() {}

	public Arithmetic add(double d) {
		SpokeDouble e=(SpokeDouble)newinstance();
		e.content=content+d;
		return e;
	}

	public Arithmetic subtract(double d) {
		SpokeDouble e=(SpokeDouble)newinstance();
		e.content=content-d;
		return e;
	}

	public Arithmetic multiply(double d) {
		SpokeDouble e=(SpokeDouble)newinstance();
		e.content=content*d;
		return e;
	}

	public Arithmetic divide(double d) {
		SpokeDouble e=(SpokeDouble)newinstance();
		e.content=content/d;
		return e;
	}

	public Arithmetic add(Arithmetic arithmetic) {
		if(arithmetic instanceof SpokeDouble) {
			return add(((SpokeDouble)arithmetic).content);
		} else {
			return arithmetic.valueof(content).add(arithmetic);
		}
	}

	public Arithmetic subtract(Arithmetic arithmetic) {
		if(arithmetic instanceof SpokeDouble) {
			return subtract(((SpokeDouble)arithmetic).content);
		} else {
			return arithmetic.valueof(content).subtract(arithmetic);
		}
	}

	public Arithmetic multiply(Arithmetic arithmetic) {
		if(arithmetic instanceof SpokeDouble) {
			return multiply(((SpokeDouble)arithmetic).content);
		} else {
			return arithmetic.multiply(content);
		}
	}

	public Arithmetic divide(Arithmetic arithmetic) {
		if(arithmetic instanceof SpokeDouble) {
			return divide(((SpokeDouble)arithmetic).content);
		} else {
			return arithmetic.valueof(content).divide(arithmetic);
		}
	}

	public Arithmetic pow(int exponent) {
		SpokeDouble e=(SpokeDouble)newinstance();
		e.content=Math.pow(content,exponent);
		return e;
	}

	public Arithmetic negate() {
		SpokeDouble e=(SpokeDouble)newinstance();
		e.content=-content;
		return e;
	}

	public int signum() {
		return content<0.?-1:(content>0.?1:0);
	}

	public Arithmetic valueof(double d) {
		SpokeDouble e=(SpokeDouble)newinstance();
		e.content=d;
		return e;
	}

	public static SpokeDouble valueOf(double d) {
		SpokeDouble e=new SpokeDouble();
		e.content=d;
		return e;
	}

	protected Arithmetic newinstance() {
		return new SpokeDouble();
	}
}
