package spoke.signal;

import java.io.*;
import spoke.math.numeric.*;

public
class ComplexPipedOutputStream extends OutputStream implements ComplexOutput {

    private ComplexPipedInputStream sink;
    boolean connected = false;

    public ComplexPipedOutputStream(ComplexPipedInputStream snk)  throws IOException {
	connect(snk);
    }
    
    public ComplexPipedOutputStream() {
    }
    
    public void connect(ComplexPipedInputStream snk) throws IOException {
	if (connected || snk.connected) {
	    throw new IOException("Already connected");
	}
	sink = snk;
	snk.closed = false;
	snk.in = -1;
	snk.out = 0;
	connected = true;
    }

    public void write(int b)  throws IOException {
	}

    public void writeComplex(Complex b)  throws IOException {
	sink.receive(b);
    }

    public void write(byte b[], int off, int len) throws IOException {
/*	sink.receive(b, off, len);
*/	}

    public synchronized void flush() throws IOException {
	if (sink != null) {
            synchronized (sink) {
                sink.notifyAll();
            }
	}
    }

    public void close()  throws IOException {
	if (sink != null) {
	    sink.receivedLast();
	}
    }
}
