package spoke.signal;

import spoke.math.numeric.*;

public class Filtre {
	protected double f[];
	protected int n;
	protected int ns2;

	public Filtre(double f[]) {
		this.f=f;
		n=f.length;
		ns2=n>>1;
	}

	public Filtre conjugue() {
		double g[]=new double[n];
		for(int i=-ns2;i<ns2;i++) {
			g[i+ns2]=f[ns2-1-i];
		}
		return newinstance(g);
	}

	public void convolution(Arithmetic in[]) {
		int nb=in.length;
		Arithmetic out[]=new Complex[nb];

		for(int i=0;i<nb;i++) {
			out[i]=Complex.valueOf(0.,0.);
			for(int j=-ns2;j<ns2;j++) out[i]=out[i].add(in[mod(i-j-1,nb)].multiply(f[j+ns2]));
		}
		for(int i=0;i<nb;i++) in[i]=out[i];
	}

	protected int mod(int i,int n) {
		return (i%n+n)%n;
	}

	protected Filtre newinstance(double f[]) {
		return new Filtre(f);
	}
}
