package spoke.signal.audio;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import javax.sound.sampled.*;
import spoke.connection.*;
import spoke.signal.*;
import spoke.math.numeric.*;

public class AudioResource extends TextField implements Connectable, ActionListener {
	Connector connector=new ComplexConnector(this,0,1);
	long longueur=0;
	transient InputStream stream;
	transient boolean state;
	transient boolean stopped;

	public AudioResource() {
		super(16);
		addActionListener(this);
	}

	public void run() {
//		ComplexInput in=new UlawInputStream(stream);
		ComplexOutput out=(ComplexOutput)connector.getOutputStream(0);

		stopped=false;
		for(long n=0;(longueur>0?n<longueur:true) && !stopped;n++) {
			try {
//				Complex c=in.readComplex();
//				if(c==null) c=Complex.valueOf(0.,0.);
//				out.writeComplex(c);
				int b=stream.read();
				if(b==-1) b=Ulaw.ZERO;
				out.writeComplex(Complex.valueOf((double)Ulaw.ulaw2int((byte)b)/(double)Short.MAX_VALUE,0.));
			} catch (InterruptedIOException e) {
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		try {
			synchronized(this) {
				while(!stopped) wait();
			}
		} catch (InterruptedException e) {}
	}

	public void stop() {
		stopped=true;
	}

	public void open() {
//		ClassLoader cl=getClass().getClassLoader();
//		URL url=cl.getResource(getText());
		try {
//			stream=new BufferedInputStream(url.openStream());
			stream=new BufferedInputStream(new FileInputStream(getText()));
			stream=AudioSystem.getAudioInputStream(stream);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public void close() {
		try {
			stream.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}

	public void connect(Connectable dest, OutputStream os, int nout) {
		connector.connect(dest,os,nout);
	}

	public void disconnect(Connectable dest) {
		connector.disconnect(dest);
	}

	public void actionPerformed(ActionEvent e) {
		if(state==false) {
			connector.start();
			state=true;
		} else {
			state=false;
			connector.stop();
		}
	}

	public synchronized void addConnectionListener(ConnectionListener l) {
		connector.addConnectionListener(l);
	}

	public synchronized void removeConnectionListener(ConnectionListener l) {
		connector.removeConnectionListener(l);
	}

	public void setLongueur(long longueur) {
		this.longueur=longueur;
	}

	public long getLongueur() {
		return(longueur);
	}
}
