package spoke.signal.audio;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.sound.sampled.*;
import spoke.connection.*;
import spoke.signal.*;

public class Microphone extends Button implements Connectable, ActionListener {
	Connector connector=new ComplexConnector(this,0,1);
	transient TargetDataLine line;
	transient boolean state;
	transient boolean stopped;

	public Microphone() {
		setLabel(getClass().getName());
		addActionListener(this);
	}

	public void run() {
		ComplexInput in=new TargetDataLineInputStream(line);
		ComplexOutput out=(ComplexOutput)connector.getOutputStream(0);

		stopped=false;
		while(!stopped) {
			try {
				out.writeComplex(in.readComplex());
			} catch (InterruptedIOException e) {
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	public void stop() {
		stopped=true;
	}

	public void open() {
		try {
			line=(TargetDataLine)AudioSystem.getLine(new DataLine.Info(TargetDataLine.class,format));
			line.open(format);
			line.start();
		} catch (LineUnavailableException ex) {
			ex.printStackTrace();
		}
	}

	public void close() {
		line.stop();
		line.close();
	}

	public void connect(Connectable dest, OutputStream os, int nout) {
		connector.connect(dest,os,nout);
	}

	public void disconnect(Connectable dest) {
		connector.disconnect(dest);
	}

	public void actionPerformed(ActionEvent e) {
		if(state==false) {
			connector.start();
			state=true;
		} else {
			state=false;
			connector.stop();
		}
	}

	public synchronized void addConnectionListener(ConnectionListener l) {
		connector.addConnectionListener(l);
	}

	public synchronized void removeConnectionListener(ConnectionListener l) {
		connector.removeConnectionListener(l);
	}

	private static final AudioFormat format=new AudioFormat(8000.0f,16,1,true,true);
}
