package spoke.signal.audio;

import java.io.*;
import javax.sound.sampled.*;
import spoke.signal.*;

public class Speaker extends Module {
	transient SourceDataLine line;

	public Speaker() {
		connector.setOutput(0);
	}

	public void run() {
		ComplexInput in=(ComplexInput)connector.getInputStream(0);
		ComplexOutput out=new SourceDataLineOutputStream(line);

		stopped=false;
		while(!stopped) {
			try {
				out.writeComplex(in.readComplex());
			} catch (InterruptedIOException e) {
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	public void open() {
		try {
			line=(SourceDataLine)AudioSystem.getLine(new DataLine.Info(SourceDataLine.class,format));
			line.open(format);
			line.start();
		} catch (LineUnavailableException ex) {
			ex.printStackTrace();
		}
	}

	public void close() {
		line.drain();
		line.stop();
		line.close();
	}

	private static final AudioFormat format=new AudioFormat(8000.0f,16,1,true,true);
}
