package spoke.signal.audio;

import java.io.*;
import javax.sound.sampled.*;
import spoke.signal.*;
import spoke.math.numeric.*;

public class TargetDataLineInputStream extends InputStream implements ComplexInput {
	TargetDataLine line;

	public TargetDataLineInputStream(TargetDataLine line) {
		this.line=line;
	}

	public int read() throws IOException {
		return -1;
	}

	public Complex readComplex() throws IOException {
		int v=readShort();
		return Complex.valueOf((double)v/(double)Short.MAX_VALUE,0.);
	}

	public int readShort() throws IOException {
		line.read(data,0,2);
		return (data[0]<<8)+data[1];
	}

	private byte data[]=new byte[2];
}
