package spoke.signal.audio;

public class Ulaw {
	public static final byte ZERO=int2ulaw(0);
	protected static int ulaw2int[]=new int[256];
	static {
		for(int i=0;i<ulaw2int.length;i++) {
			int c=~i;
			int s=(c&0x80)>>7;
			int e=(c&0x70)>>4;
			int m=c&0x0f;
			ulaw2int[i]=s==0?(m<<(e+3))+(((1<<e)-1)*132):-((m<<(e+3))+(((1<<e)-1)*132));
		}
	}

	public static int ulaw2int(byte b) {
		return ulaw2int[(int)b & 0xff];
	}

	public static byte int2ulaw(int x) {
		int s=x<0?1:0;
		int y=x<0?(~x)+8:x+4;
		int e=Math.min(log2e((y>>7)+1),7);
		int m=Math.min((y-(((1<<e)-1)<<7))>>(e+3),15);
		return (byte)(~((s<<7)|(e<<4)|m));
	}

	protected static int log2e(int n) {
		int i;
		for(i=0;n>1;n>>=1) i++;
		return i;
	}
}
