package spoke.signal.chaos;

import spoke.signal.*;

public class LZ {
	double minimum[]={0.0,0.0,45.0};
	double maximum[]={30.0,50.0,90.0};
	double r;
	double sigma;
	double b;
	double dt;
	double x;
	double y;
	double z;

	public LZ(double r, double sigma, double b, double dt) {
		this.r=r;
		this.sigma=sigma;
		this.b=b;
		this.dt=dt;
		x=0.1;
		y=0.0;
		z=0.0;
	}

	public double[] compute() {
		double p[]={x,y,z};
		for(int i=0;i<p.length;i++) p[i]=(p[i]-minimum[i])/(maximum[i]-minimum[i]);
		return p;
	}

	public void next() {
		x+=dt*sigma*(y-x);
		y+=dt*(r*x-y-x*z);
		z+=dt*(-b*z+x*y);
	}
}
