package spoke.signal.fourier;

import java.io.*;
import spoke.signal.*;
import spoke.math.numeric.*;

public class Fourier extends Module {
	int dyades=0;
	boolean hamming=false;
	boolean sens=false;
	transient TFR tfr;
	transient Complex buffer[];
	transient double fenetre[];

	public void run() {
		ComplexInput in=(ComplexInput)connector.getInputStream(0);
		ComplexOutput out=(ComplexOutput)connector.getOutputStream(0);

		stopped=false;
		while(!stopped) {
			try {
				for(int i=0;i<buffer.length;i++) buffer[i]=in.readComplex();
				if(sens) {
					tfr.compute(buffer,true);
					if(hamming) for(int i=0;i<buffer.length;i++) buffer[i]=(Complex)buffer[i].divide(fenetre[i]);
				} else {
					if(hamming) for(int i=0;i<buffer.length;i++) buffer[i]=(Complex)buffer[i].multiply(fenetre[i]);
					tfr.compute(buffer,false);
				}
				for(int i=0;i<buffer.length;i++) out.writeComplex(buffer[i]);
			} catch (InterruptedIOException e) {
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	public void init() {
		tfr=new TFR(1<<dyades);
		buffer=new Complex[1<<dyades];
		fenetre=new double[1<<dyades];
		for(int i=0;i<fenetre.length;i++) fenetre[i]=.54-.46*Math.cos(2.*Math.PI*(double)i/(double)fenetre.length);
	}

	public void open() {
		init();
	}

	public void setDyades(int dyades) {
		this.dyades=dyades;
		init();
	}

	public int getDyades() {
		return(dyades);
	}

	public void setHamming(boolean hamming) {
		this.hamming=hamming;
	}

	public boolean getHamming() {
		return(hamming);
	}

	public void setSens(boolean sens) {
		this.sens=sens;
	}

	public boolean getSens() {
		return(sens);
	}
}
