package spoke.signal.fourier;

import java.io.*;
import spoke.signal.*;
import spoke.math.numeric.*;

public class Fourier2 extends Fourier {
	public void run() {
		ComplexInput in=(ComplexInput)connector.getInputStream(0);
		ComplexOutput out=(ComplexOutput)connector.getOutputStream(0);
		int length=buffer.length>>1;

		stopped=false;
		while(!stopped) {
			try {
				if(sens) {
					for(int i=0;i<length;i++) buffer[i]=in.readComplex();
					for(int i=0;i<length;i++) buffer[i+length]=buffer[i==0?0:length-i].conjugate();
					tfr.compute(buffer,true);
					if(hamming) for(int i=0;i<buffer.length;i++) buffer[i]=(Complex)buffer[i].divide(fenetre[i]);
					for(int i=0;i<buffer.length;i++) out.writeComplex(buffer[i]);
				} else {
					for(int i=0;i<buffer.length;i++) buffer[i]=in.readComplex();
					if(hamming) for(int i=0;i<buffer.length;i++) buffer[i]=(Complex)buffer[i].multiply(fenetre[i]);
					tfr.compute(buffer,false);
					for(int i=0;i<length;i++) out.writeComplex(buffer[i]);
				}
			} catch (InterruptedIOException e) {
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}
