package spoke.signal.fourier;

import java.io.*;
import spoke.signal.*;
import spoke.math.numeric.*;

public class Recouvrement extends Module {
	int dyades=0;
	int rate=1;
	boolean sens=false;
	transient Complex buffer[];

	public void run() {
		ComplexInput in=(ComplexInput)connector.getInputStream(0);
		ComplexOutput out=(ComplexOutput)connector.getOutputStream(0);
		int length=sens?buffer.length*rate:buffer.length/rate;
		int index=0;

		stopped=false;
		while(!stopped) {
			try {
				for(int i=0;i<length;i++) buffer[(index++)%buffer.length]=in.readComplex();
				for(int i=0;i<buffer.length;i++) out.writeComplex(buffer[(i+index)%buffer.length]);
				index=index%buffer.length;
			} catch (InterruptedIOException e) {
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	public void init() {
		buffer=new Complex[1<<dyades];
	}

	public void open() {
		init();
		for(int i=0;i<buffer.length;i++) buffer[i]=Complex.valueOf(0.,0.);
	}

	public void setDyades(int dyades) {
		this.dyades=dyades;
		init();
	}

	public int getDyades() {
		return(dyades);
	}

	public void setRate(int rate) {
		this.rate=rate;
	}

	public int getRate() {
		return(rate);
	}

	public void setSens(boolean sens) {
		this.sens=sens;
	}

	public boolean getSens() {
		return(sens);
	}
}
