package spoke.signal.fourier;

import java.io.*;
import spoke.signal.*;
import spoke.math.numeric.*;

public class SignalAnalytique extends Module {
	int dyades=0;
	boolean sens=false;
	transient TFR tfr;
	transient Complex buffer[];

	public void run() {
		ComplexInput in=(ComplexInput)connector.getInputStream(0);
		ComplexOutput out=(ComplexOutput)connector.getOutputStream(0);
		int length=buffer.length>>1;

		stopped=false;
		while(!stopped) {
			try {
				for(int i=0;i<buffer.length;i++) buffer[i]=in.readComplex();
				tfr.compute(buffer,false);
				if(sens) {
					for(int i=0;i<length;i++) buffer[i]=(Complex)buffer[i].multiply(.5);
					for(int i=0;i<length;i++) buffer[i+length]=buffer[i==0?0:length-i].conjugate();
				} else {
					for(int i=0;i<length;i++) buffer[i]=(Complex)buffer[i].multiply(2.);
					for(int i=0;i<length;i++) buffer[i+length]=Complex.valueOf(0.,0.);
				}
				tfr.compute(buffer,true);
				for(int i=0;i<buffer.length;i++) out.writeComplex(buffer[i]);
			} catch (InterruptedIOException e) {
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	public void init() {
		tfr=new TFR(1<<dyades);
		buffer=new Complex[1<<dyades];
	}

	public void open() {
		init();
	}

	public void setDyades(int dyades) {
		this.dyades=dyades;
		init();
	}

	public int getDyades() {
		return(dyades);
	}

	public void setSens(boolean sens) {
		this.sens=sens;
	}

	public boolean getSens() {
		return(sens);
	}
}
