package spoke.signal.fourier;

import spoke.math.numeric.*;

public class TFR {
	int n;
	int ns2;
	Arithmetic w[],w_[];

	public TFR(int n) {
		this.n=n;
		ns2=n>>1;
		w=new Complex[ns2];
		w_=new Complex[ns2];
		for(int i=0;i<ns2;i++) w[i]=Complex.valueOf(0.0,(double)i*Math.PI/(double)ns2).exp();
		for(int i=0;i<ns2;i++) w_[i]=Complex.valueOf(0.0,-(double)i*Math.PI/(double)ns2).exp();
	}

	public void compute(Arithmetic x[], boolean sens) {
		int i,j,jf2=0,k,l,m;
		int nu=log2e(n);
		double sqrn=Math.sqrt((double)n);
		Arithmetic y[]=new Complex[n];
		Arithmetic z[]=new Complex[n];

		for(i=0;i<n;i++) y[i]=x[ret(i,nu)];
		for(j=1,l=ns2;j<n;j=jf2,l>>=1) {
			jf2=j<<1;
			if(sens) {
				for(i=0;i<n;i++) {
					k=i&(jf2-1);
					if(k<j) z[i]=y[i];
					else {
						m=l*(k-j);
						z[i]=y[i].multiply(w[m]);
					}
				}
			}
			else {
				for(i=0;i<n;i++) {
					k=i&(jf2-1);
					if(k<j) z[i]=y[i];
					else {
						m=l*(k-j);
						z[i]=y[i].multiply(w_[m]);
					}
				}
			}
			for(i=0;i<n;i++) {
				k=i&(jf2-1);
				m=((j+k)&(jf2-1))+i-k;
				if(k<j) y[i]=z[i].add(z[m]);
				else y[i]=z[m].subtract(z[i]);
			}
		}
		for(i=0;i<n;i++) x[i]=y[i].divide(sqrn);
	}

	protected static int ret(int n, int nu) {
		int p=0;
		for(int i=0;i<nu;i++) {
			p<<=1;
			p+=(n&1);
			n>>=1;
		}
		return p;
	}

	protected static int log2e(int n) {
		int i;
		for(i=0;n>1;n>>=1) i++;
		return i;
	}
}
