package spoke.signal.image;

import java.io.*;
import java.awt.*;
import java.awt.image.*;
import spoke.connection.*;
import spoke.signal.*;
import spoke.math.numeric.*;

public class ImageInputStream implements ComplexInput {
	float hsbvals[];
	int pixels[];
	int largeur;
	int hauteur;
	int index;

	public ImageInputStream(Image image) {
		hsbvals=new float[3];
		PixelGrabber grabber=new PixelGrabber(image,0,0,-1,-1,true);
		try {
			grabber.grabPixels();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		pixels=(int[])grabber.getPixels();
		largeur=grabber.getWidth();
		hauteur=grabber.getHeight();
		index=0;
	}

	public final Complex readComplex() throws IOException {
		int x=index/hauteur;
		int y=index%hauteur;
		if(index==pixels.length) return null;
		else {
//			Color c=new Color(pixels[(hauteur-1-y)*largeur+x]);
//			Color.RGBtoHSB(c.getRed(),c.getGreen(),c.getBlue(),hsbvals);
			int c=pixels[(hauteur-1-y)*largeur+x];
			Color.RGBtoHSB((c&0x00ff0000)>>16,(c&0x0000ff00)>>8,c&0x000000ff,hsbvals);
			index++;
			return Complex.valueOf((double)hsbvals[2],0.);
		}
	}
}
