package spoke.signal.image;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import sun.awt.image.*;
import spoke.connection.*;
import spoke.signal.*;
import spoke.math.numeric.*;

public class ImageResource extends TextField implements Connectable, ActionListener {
	Connector connector=new ComplexConnector(this,0,1);
	int largeur=0;
	int hauteur=0;
	transient java.awt.Image image;
	transient boolean state;
	transient boolean stopped;

	public ImageResource() {
		super(16);
		addActionListener(this);
	}

	public void run() {
		ComplexInput in=new ImageInputStream(image);
		ComplexOutput out=(ComplexOutput)connector.getOutputStream(0);

		stopped=false;
		while(!stopped) {
			try {
				Complex c=in.readComplex();
				if(c==null) break;
				else out.writeComplex(c);
			} catch (InterruptedIOException e) {
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		try {
			synchronized(this) {
				while(!stopped) wait();
			}
		} catch (InterruptedException e) {}
	}

	public void stop() {
		stopped=true;
	}

	public void open() {
//		ClassLoader cl=getClass().getClassLoader();
//		URL url=cl.getResource(getText());
		java.awt.image.ImageProducer ip;
//		ip=new URLImageSource(url);
		ip=new FileImageSource(getText());
		image=createImage(ip).getScaledInstance(largeur,hauteur,java.awt.Image.SCALE_DEFAULT);
	}

	public void close() {}

	public void connect(Connectable dest, OutputStream os, int nout) {
		connector.connect(dest,os,nout);
	}

	public void disconnect(Connectable dest) {
		connector.disconnect(dest);
	}

	public void actionPerformed(ActionEvent e) {
		if(state==false) {
			connector.start();
			state=true;
		} else {
			state=false;
			connector.stop();
		}
	}

	public synchronized void addConnectionListener(ConnectionListener l) {
		connector.addConnectionListener(l);
	}

	public synchronized void removeConnectionListener(ConnectionListener l) {
		connector.removeConnectionListener(l);
	}

	public void setLargeur(int largeur) {
		this.largeur=largeur;
	}

	public int getLargeur() {
		return(largeur);
	}

	public void setHauteur(int hauteur) {
		this.hauteur=hauteur;
	}

	public int getHauteur() {
		return(hauteur);
	}
}
