package spoke.signal.kohonen;

import java.util.*;

public class Carre extends Damier {
	public Carre(int dimension, int width, int height) {
		super(dimension,width,height);
		node=new SOMNode[width*height];
		for(int i=0;i<node.length;i++) node[i]=node(i);
		r=Math.max(width,height);
		l=.2;
	}

	public SOMNode node(int n) {
		SOMNode node=new SOMNode(Node.randomize(dimension));
		int c[]=coordonnee(n);
		int x=c[0];
		int y=c[1];

		if(x==0 || x==width-1) {
			node.addElement(new Proximite(index(x==0?x+1:x-1,y)));
		} else {
			node.addElement(new Proximite(index(x-1,y)));
			node.addElement(new Proximite(index(x+1,y)));
		}
		if(y==0 || y==height-1) {
			node.addElement(new Proximite(index(x,y==0?y+1:y-1)));
		} else {
			node.addElement(new Proximite(index(x,y-1)));
			node.addElement(new Proximite(index(x,y+1)));
		}
		node.trimToSize();
		return node;
	}

	public double[][][] surface() {
		Vector v=new Vector();

		for(int x=0;x<width-1;x++) {
			for(int y=0;y<height-1;y++) {
				double d[][]=new double[4][dimension];
				for(int k=0;k<dimension;k++) {
					d[0][k]=node[index(x,y)].weight[k];
					d[1][k]=node[index(x+1,y)].weight[k];
					d[2][k]=node[index(x+1,y+1)].weight[k];
					d[3][k]=node[index(x,y+1)].weight[k];
				}
				v.addElement(d);
			}
		}
		double d[][][]=new double[v.size()][][];
		v.copyInto(d);
		return d;
	}
}
