package spoke.signal.kohonen;

import java.io.*;

public class Node implements Serializable {
	public double weight[];
	public String code;

	public Node(double weight[], String code) {
		this.weight=weight;
		this.code=code;
	}

	public double distance(double sample[]) {
		double d=0.;
		for(int i=0;i<weight.length;i++) {
			double e=weight[i]-sample[i];
			d+=e*e;
		}
		return Math.sqrt(d);
	}

	public void move(double sample[], double l, boolean sens) {
		for(int i=0;i<weight.length;i++) {
			weight[i]+=(sens?weight[i]-sample[i]:sample[i]-weight[i])*l;
		}
	}

	public static double[] randomize(int dimension) {
		double weight[]=new double[dimension];
		for(int i=0;i<weight.length;i++) weight[i]=Math.random()*.2-.1;
		return weight;
	}
}
