package spoke.signal.misc;

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import spoke.connection.*;
import spoke.signal.*;
import spoke.math.numeric.*;

public class Bruit extends Button implements Connectable, ActionListener {
	Connector connector=new ComplexConnector(this,0,1);
	double mean=0.0;
	double deviation=1.0;
	transient boolean state;
	transient Random random;
	transient boolean stopped;

	public Bruit() {
		setLabel(getClass().getName());
		addActionListener(this);
	}

	public void run() {
		ComplexOutput out=(ComplexOutput)connector.getOutputStream(0);

		stopped=false;
		while(!stopped) {
			try {
				out.writeComplex(Complex.valueOf(random.nextGaussian()*deviation+mean,0.));
			} catch (InterruptedIOException e) {
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	public void stop() {
		stopped=true;
	}

	public void init() {
		random=new Random();
	}

	public void open() {
		init();
	}

	public void close() {}

	public void connect(Connectable dest, OutputStream os, int nout) {
		connector.connect(dest,os,nout);
	}

	public void disconnect(Connectable dest) {
		connector.disconnect(dest);
	}

	public void actionPerformed(ActionEvent e) {
		if(state==false) {
			connector.start();
			state=true;
		} else {
			state=false;
			connector.stop();
		}
	}

	public synchronized void addConnectionListener(ConnectionListener l) {
		connector.addConnectionListener(l);
	}

	public synchronized void removeConnectionListener(ConnectionListener l) {
		connector.removeConnectionListener(l);
	}

	public void setMean(double mean) {
		this.mean=mean;
	}

	public double getMean() {
		return(mean);
	}

	public void setDeviation(double deviation) {
		this.deviation=deviation;
	}

	public double getDeviation() {
		return(deviation);
	}
}
