package spoke.signal.misc;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import spoke.connection.*;
import spoke.signal.*;
import spoke.math.numeric.*;

public class Dirac extends Button implements Connectable, ActionListener {
	Connector connector=new ComplexConnector(this,0,1);
	long longueur=0;
	long temps=0;
	transient boolean state;
	transient boolean stopped;

	public Dirac() {
		setLabel(getClass().getName());
		addActionListener(this);
	}

	public void run() {
		ComplexOutput out=(ComplexOutput)connector.getOutputStream(0);

		stopped=false;
		for(long n=0;(longueur>0?n<longueur:true) && !stopped;n++) {
			try {
				if(n==temps) out.writeComplex(Complex.valueOf(1.,0.));
				else out.writeComplex(Complex.valueOf(0.,0.));
			} catch (InterruptedIOException e) {
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		try {
			synchronized(this) {
				while(!stopped) wait();
			}
		} catch (InterruptedException e) {}
	}

	public void stop() {
		stopped=true;
	}

	public void open() {}

	public void close() {}

	public void connect(Connectable dest, OutputStream os, int nout) {
		connector.connect(dest,os,nout);
	}

	public void disconnect(Connectable dest) {
		connector.disconnect(dest);
	}

	public void actionPerformed(ActionEvent e) {
		if(state==false) {
			connector.start();
			state=true;
		} else {
			state=false;
			connector.stop();
		}
	}

	public synchronized void addConnectionListener(ConnectionListener l) {
		connector.addConnectionListener(l);
	}

	public synchronized void removeConnectionListener(ConnectionListener l) {
		connector.removeConnectionListener(l);
	}

	public void setLongueur(long longueur) {
		this.longueur=longueur;
	}

	public long getLongueur() {
		return(longueur);
	}

	public void setTemps(long temps) {
		this.temps=temps;
	}

	public long getTemps() {
		return temps;
	}
}
