package spoke.signal.misc;

import java.io.*;
import spoke.signal.*;
import spoke.math.numeric.*;

public class Modulateur extends Module {
	int mode=0;
	double frequence=0.0;
	boolean sens=false;

	public void run() {
		ComplexInput in=(ComplexInput)connector.getInputStream(0);
		ComplexOutput out=(ComplexOutput)connector.getOutputStream(0);

		stopped=false;
		for(long n=0;!stopped;n++) {
			try {
				Complex c=in.readComplex();
				Complex porteuse=Complex.valueOf(0.,2.*Math.PI*frequence*(double)n).exp();
				if(sens) {
					Complex m=((Complex)c.divide(porteuse)).log();
					out.writeComplex(Complex.valueOf(mode==0?m.element0:m.element1,0.));
				} else {
					Complex m=mode==0?Complex.valueOf(c.element0,0.):Complex.valueOf(0.,c.element0);
					out.writeComplex((Complex)porteuse.multiply(m.exp()));
				}
			} catch (InterruptedIOException e) {
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	public void setMode(int mode) {
		this.mode=mode<0?0:(mode>=2?1:mode);
	}

	public int getMode() {
		return mode;
	}

	public void setFrequence(double frequence) {
		this.frequence=frequence;
	}

	public double getFrequence() {
		return frequence;
	}

	public void setSens(boolean sens) {
		this.sens=sens;
	}

	public boolean getSens() {
		return(sens);
	}
}
