package spoke.signal.ondelette;

import java.io.*;
import spoke.signal.*;
import spoke.math.numeric.*;

public class AlgorithmeATrous extends Module {
	int dyades=0;
	int resume=0;
	int octave=0;
	int voie=1;
	transient ATR atr;
	transient Complex buffer[];
	transient int largeur;
	transient int hauteur;
	transient Complex buffer2[][];

	public void run() {
		ComplexInput in=(ComplexInput)connector.getInputStream(0);
		ComplexOutput out=(ComplexOutput)connector.getOutputStream(0);

		stopped=false;
		while(!stopped) {
			try {
				for(int i=0;i<buffer.length;i++) buffer[i]=in.readComplex();
				atr.compute(buffer,buffer2,octave);
				for(int x=0;x<largeur;x++) for(int y=0;y<hauteur;y++) out.writeComplex(buffer2[y][x]);
			} catch (InterruptedIOException e) {
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	public void init() {
		atr=new ATR(1<<dyades,resume,voie);
		buffer=new Complex[1<<dyades];
		largeur=(1<<dyades)>>resume;
		hauteur=octave*voie;
		buffer2=new Complex[hauteur][largeur];
	}

	public void open() {
		init();
	}

	public void setDyades(int dyades) {
		this.dyades=dyades;
		if(octave>dyades) octave=dyades;
		init();
	}

	public int getDyades() {
		return(dyades);
	}

	public void setResume(int resume) {
		this.resume=resume<0?0:resume;
		init();
	}

	public int getResume() {
		return(resume);
	}

	public void setVoie(int voie) {
		this.voie=voie;
		init();
	}

	public int getVoie() {
		return(voie);
	}

	public void setOctave(int octave) {
		this.octave=octave;
		if(dyades<octave) dyades=octave;
		init();
	}

	public int getOctave() {
		return(octave);
	}
}
