package spoke.signal.ondelette;

import spoke.math.numeric.*;

public class Filtre extends spoke.signal.Filtre {
	public Filtre(double f[]) {
		super(f);
	}

	public Filtre miroir() {
		double g[]=new double[n];
		for(int i=-ns2;i<ns2;i++) {
			int p=(i-ns2)&1;
			g[i+ns2]=p==1?-f[ns2-1-i]:f[ns2-1-i];
		}
		return (Filtre)newinstance(g);
	}

	public void convolution_decimation(Arithmetic in[],Arithmetic out[],int o,int nb) {
		int nbs2=nb>>1;

		for(int i=0;i<nbs2;i++) {
			out[i+o]=Complex.valueOf(0.,0.);
			for(int j=-ns2;j<ns2;j++) out[i+o]=out[i+o].add(in[mod((i<<1)-j-1,nb)].multiply(f[j+ns2]));
		}
	}

	public void dilatation_convolution(Arithmetic in[],Arithmetic out[],int o,int nb) {
		int nbf2=nb<<1;

		for(int i=0;i<nbf2;i++) {
			int p=(i-ns2)&1;
			out[i]=Complex.valueOf(0.,0.);
			for(int j=-ns2;j<ns2;j+=2) out[i]=out[i].add(in[mod((i-j-p)>>1,nb)+o].multiply(f[j+p+ns2]));
		}
	}

	protected spoke.signal.Filtre newinstance(double f[]) {
		return new Filtre(f);
	}
}
