package spoke.signal.ondelette;

import java.io.*;
import spoke.signal.*;
import spoke.math.numeric.*;

public class Ondelette extends Module {
	int dyades=0;
	int ondelette=1;
	int resolution=0;
	boolean sens=false;
	transient TOR tor;
	transient Complex buffer[];

	public void run() {
		ComplexInput in=(ComplexInput)connector.getInputStream(0);
		ComplexOutput out=(ComplexOutput)connector.getOutputStream(0);

		stopped=false;
		while(!stopped) {
			try {
				for(int i=0;i<buffer.length;i++) buffer[i]=in.readComplex();
				tor.compute(buffer,resolution,sens);
				for(int i=0;i<buffer.length;i++) out.writeComplex(buffer[i]);
			} catch (InterruptedIOException e) {
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	public void init() {
		spoke.signal.ondelette.Filtre h;
		if(ondelette==0) h=new Lemarie();
		else h=new Daubechies(ondelette);
		tor=new TOR(1<<dyades,h);
		buffer=new Complex[1<<dyades];
	}

	public void open() {
		init();
	}

	public void setDyades(int dyades) {
		this.dyades=dyades;
		if(resolution>dyades) resolution=dyades;
		init();
	}

	public int getDyades() {
		return(dyades);
	}

	public void setOndelette(int ondelette) {
		this.ondelette=ondelette<0?0:(ondelette>10?10:ondelette);
		spoke.signal.ondelette.Filtre h;
		if(ondelette==0) h=new Lemarie();
		else h=new Daubechies(ondelette);
		tor=new TOR(1<<dyades,h);
	}

	public int getOndelette() {
		return(ondelette);
	}

	public void setResolution(int resolution) {
		this.resolution=resolution;
		if(dyades<resolution) setDyades(resolution);
	}

	public int getResolution() {
		return(resolution);
	}

	public void setSens(boolean sens) {
		this.sens=sens;
	}

	public boolean getSens() {
		return(sens);
	}
}
