package spoke.signal.ondelette;

import java.io.*;
import spoke.signal.*;
import spoke.math.numeric.*;

public class Ondelette2D extends Module {
	int dyades_largeur=0;
	int dyades_hauteur=0;
	int ondelette=1;
	int resolution=0;
	boolean sens=false;
	transient TOR2D tor;
	transient Complex buffer[][];
	transient int largeur;
	transient int hauteur;

	public void run() {
		ComplexInput in=(ComplexInput)connector.getInputStream(0);
		ComplexOutput out=(ComplexOutput)connector.getOutputStream(0);

		stopped=false;
		while(!stopped) {
			try {
				for(int x=0;x<largeur;x++) for(int y=0;y<hauteur;y++) buffer[x][y]=in.readComplex();
				tor.compute(buffer,resolution,sens);
				for(int x=0;x<largeur;x++) for(int y=0;y<hauteur;y++) out.writeComplex(buffer[x][y]);
			} catch (InterruptedIOException e) {
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	public void init() {
		spoke.signal.ondelette.Filtre h;
		if(ondelette==0) h=new Lemarie();
		else h=new Daubechies(ondelette);
		largeur=1<<dyades_largeur;
		hauteur=1<<dyades_hauteur;
		tor=new TOR2D(largeur,hauteur,h);
		buffer=new Complex[largeur][hauteur];
	}

	public void open() {
		init();
	}

	public void setDyades_largeur(int dyades_largeur) {
		this.dyades_largeur=dyades_largeur;
		if(resolution>dyades_largeur) resolution=dyades_largeur;
		init();
	}

	public int getDyades_largeur() {
		return(dyades_largeur);
	}

	public void setDyades_hauteur(int dyades_hauteur) {
		this.dyades_hauteur=dyades_hauteur;
		if(resolution>dyades_hauteur) resolution=dyades_hauteur;
		init();
	}

	public int getDyades_hauteur() {
		return(dyades_hauteur);
	}

	public void setOndelette(int ondelette) {
		this.ondelette=ondelette<0?0:(ondelette>10?10:ondelette);
		spoke.signal.ondelette.Filtre h;
		if(ondelette==0) h=new Lemarie();
		else h=new Daubechies(ondelette);
		tor=new TOR2D(1<<dyades_largeur,1<<dyades_hauteur,h);
	}

	public int getOndelette() {
		return(ondelette);
	}

	public void setResolution(int resolution) {
		this.resolution=resolution;
		if(dyades_largeur<resolution) setDyades_largeur(resolution);
		if(dyades_hauteur<resolution) setDyades_hauteur(resolution);
	}

	public int getResolution() {
		return(resolution);
	}

	public void setSens(boolean sens) {
		this.sens=sens;
	}

	public boolean getSens() {
		return(sens);
	}
}
