package spoke.signal.ondelette;

import spoke.math.numeric.*;

public class TOR {
	int n;
	Filtre h,h_;
	Filtre g,g_;

	public TOR(int n, Filtre h) {
		this.n=n;
		this.h=h;
		h_=(Filtre)h.conjugue();
		g=h.miroir();
		g_=(Filtre)g.conjugue();
	}

	public void compute(Arithmetic x[], int resolution, boolean sens) {
		int nb;
		int nbs2;
		int nbf2;
		int m=n>>resolution;
		Arithmetic y[]=new Complex[n];
		Arithmetic z[]=new Complex[n];

		if(sens) for(nbf2=nb=m;nbf2<n;nb=nbf2) {
			nbf2=nb<<1;
			h_.dilatation_convolution(x,y,0,nb);
			g_.dilatation_convolution(x,z,nb,nb);
			for(int i=0;i<nbf2;i++) x[i]=y[i].add(z[i]);
		} else for(nbs2=nb=n;nbs2>m;nb=nbs2) {
			nbs2=nb>>1;
			h.convolution_decimation(x,y,0,nb);
			g.convolution_decimation(x,y,nbs2,nb);
			for(int i=0;i<nb;i++) x[i]=y[i];
		}
	}
}
