package spoke.signal.parole;

import java.io.*;
import spoke.signal.*;
import spoke.math.numeric.*;

public class Preaccentuation extends Module {
	static final double F[]={-.94,1.};
	int dyades=0;
	boolean desactive=false;
	transient Complex buffer[];
	transient Filtre filtre;

	public void run() {
		ComplexInput in=(ComplexInput)connector.getInputStream(0);
		ComplexOutput out=(ComplexOutput)connector.getOutputStream(0);

		stopped=false;
		while(!stopped) {
			try {
				for(int i=0;i<buffer.length;i++) buffer[i]=in.readComplex();
				if(!desactive) filtre.convolution(buffer);
				for(int i=0;i<buffer.length;i++) out.writeComplex(buffer[i]);
			} catch (InterruptedIOException e) {
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	public void init() {
		buffer=new Complex[1<<dyades];
		filtre=new Filtre(F);
	}

	public void open() {
		init();
	}

	public void setDyades(int dyades) {
		this.dyades=dyades;
		init();
	}

	public int getDyades() {
		return(dyades);
	}

	public void setDesactive(boolean desactive) {
		this.desactive=desactive;
	}

	public boolean getDesactive() {
		return(desactive);
	}
}
