package spoke.signal.util;

import java.awt.*;
import java.beans.*;

public class Curseur extends Scrollbar {
	private PropertyChangeSupport changes = new PropertyChangeSupport(this);
	double coefficient=1.0;
	double commande=0.0;

	public void setValue(int value) {
		int oldValue=getValue();
		super.setValue(value);
		changes.firePropertyChange("value", new Integer(oldValue), new Integer(value));
		setCommande((double)value*coefficient);
	}

	public void setCommande(double commande) {
		double oldCommande=getCommande();
		this.commande=commande;
		changes.firePropertyChange("commande", new Double(oldCommande), new Double(commande));
	}

	public double getCommande() {
		return commande;
	}

	public void setCoefficient(double coefficient) {
		this.coefficient=coefficient;
	}

	public double getCoefficient() {
		return coefficient;
	}

	public void addPropertyChangeListener(PropertyChangeListener l) {
		changes.addPropertyChangeListener(l);
	}

	public void removePropertyChangeListener(PropertyChangeListener l) {
		changes.removePropertyChangeListener(l);
	}
}
