package spoke.signal.util;

import java.io.*;
import spoke.signal.*;
import spoke.math.numeric.*;

public class Logarithme extends Module {
	static final double LOG10=Math.log(10.0);
	double seuil=1.0e-1;
	boolean sens=false;

	public void run() {
		ComplexInput in=(ComplexInput)connector.getInputStream(0);
		ComplexOutput out=(ComplexOutput)connector.getOutputStream(0);

		stopped=false;
		while(!stopped) {
			try {
				Complex c=in.readComplex();
				if(sens) {
					Complex z=c;
					z.element0*=LOG10;
					out.writeComplex(z.exp());
				} else {
					Complex z=c.log(seuil);
					z.element0/=LOG10;
					out.writeComplex(z);
				}
			} catch (InterruptedIOException e) {
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	public void setSeuil(double seuil) {
		this.seuil=seuil;
	}

	public double getSeuil() {
		return seuil;
	}

	public void setSens(boolean sens) {
		this.sens=sens;
	}

	public boolean getSens() {
		return(sens);
	}
}
