package spoke.space;

import java.awt.*;
import java.util.*;
import spoke.math.numeric.*;
import spoke.util.*;

public class SurfaceViewer extends StereoViewer {
	static final double LUMIERE[]={0.,0.,1.};
	SpokeVector lumiere;

	public void setModele(Modele modele) {
		super.setModele(modele);
		lumiere=new SpokeVector(new double[dimension]);
		for(int i=0;i<LUMIERE.length;i++) lumiere.element[i]=LUMIERE[i];
		lumiere=lumiere.normalize();
	}

	void myPaint(Graphics g) {
		Betatree perspective=new Betatree(PolygonComparator.comparator);
		double data[][][]=modele.getData();

		for(int i=0;i<data.length;i++) {
			double p[][]=data[i];
			double q[][]=new double[p.length][];
			for(int j=0;j<p.length;j++) {
				q[j]=((SpokeVector)decale.multiply(new SpokeVector(p[j]))).element;
			}
			perspective.put(q,null);
		}
		for(Enumeration e=perspective.keys();e.hasMoreElements();) {
			double q[][]=(double[][])e.nextElement();
			int x[][]=projection(q);
//			g.setColor(Color.getHSBColor((float)0.,(float)0.,(float)intensite(q)));
			g.setColor(new Color((float)intensite(q),(float)0.,(float)(intensite(q)*.5)));
			g.fillPolygon(x[0],x[1],q.length);
			g.setColor(Color.black);
//			g.drawPolygon(x[0],x[1],q.length);
		}
	}

	double intensite(double p[][]) {
		SpokeVector v1=(SpokeVector)new SpokeVector(p[1]).subtract(new SpokeVector(p[0]));
		SpokeVector v2=(SpokeVector)new SpokeVector(p[2]).subtract(new SpokeVector(p[0]));
		SpokeVector normal=v1.vectorProduct(v2).normalize();
		return Math.abs(normal.scalarProduct(lumiere));
	}
}
